/**
 *
 * Sections JS file
 *
 */
jQuery(document).ready(function() {

  //Global function
  function get_attest_curriculum(element) {

    var containers = jQuery(element).closest('#section_append_to').children('#section_container');
    var titles = jQuery(element).closest('#section_append_to').find("input[id='attest_curriculum_title']")
    .map(function(){return jQuery(this).val();}).get();

    var data_obj = [];
    containers.each(function(i, select_container){
      var lessons_obj = jQuery(select_container).find("select[id='attest_lesson_id']")
      .map(function(){return jQuery('option:selected', this).val();}).get();
      var conditions_obj = jQuery(select_container).find("select[id='attest_lesson_condition']")
      .map(function(){return jQuery('option:selected', this).val();}).get();

      var output_obj = [];
      jQuery(lessons_obj).each(function(item, lesson){
        var arr = [];
        arr.push({'lesson_id': lesson});
        arr.push({'condition': conditions_obj[item]});
        output_obj.push(arr);
      });
      data_obj[i] = output_obj;
    });

    var final_obj = [];
    jQuery(titles).each(function(item, value) {
      var arr = [];
      arr.push({'title': value});
      arr.push({item: data_obj[item]});
      final_obj[item] = arr;
    });

    return final_obj;
  }


  //Init
  jQuery('#attest_curriculum_title, #save_title').hide();


  //Add new section
  jQuery(document).delegate('.new_section', 'click', function(){

    var section_html = jQuery('#appendFrom').html();
    var section_Serial = jQuery(this).parent().parent().parent().children('#section_append_to').children('#section_container').last().children('#section').children('#section_ID').attr('data-serial');
    var title = jQuery(this).prev('#add_new_section').val();

    jQuery('#add_new_section').val('');

    if (section_Serial == undefined) {
      var section_count = 0;
    } else {
      var section_count = parseInt(section_Serial) + 1;
    }

    var altered_section_html = jQuery(section_html).find('#section_ID').attr('data-serial', section_count).end()
    .find('#attest_curriculum_title').attr('name', 'attest_curriculum['+section_count+'][title]').val(title).end()
    .find('#lesson_container').remove().end()
    .find('#accordion_title_number_section').text(section_count+1).end()
    .find('#accordion_title_name_section').text(title).end()
    .find('#attest_curriculum_title').text(title).end();

    jQuery(this).parent().parent().prev('#section_append_to').append(altered_section_html);
  });


  //Delete section
  jQuery(document).delegate('.delete_section', 'click', function(){
    if (!confirm(sjax.delete_section)){
      return false;
    } else {
      var count_lessons_obj = jQuery(this).closest('#section_append_to').find('#lesson_container');

      jQuery(this).parent().parent().parent().parent().parent().remove();

      var sections = jQuery('span[id="accordion_title_number_section"]');
      sections.each(function(i,v){
        if (i < sections.length) {
          jQuery(v).text(i+1);
        }
      });

      count_lessons_obj.each(function(i, v) {
        if (count_lessons_obj.length <= 1) {
          jQuery(v).find('#attest_lesson_condition').attr('disabled', 'disabled');
        } else {
          jQuery(v).find('#attest_lesson_condition').removeAttr('disabled');
        }
      });
    }
  });


  //Add new lesson
  jQuery(document).delegate('.new_lesson', 'click', function(){

    var element = this;
    var title = jQuery(this).prev('#add_new_lesson').val();
    var course_id = jQuery(this).parent().find('#attest_course_id').val();
    var nonce = jQuery(this).parent().find('#attest_new_lesson_nonce').val();

    if (title != undefined && title != '' && course_id != undefined && course_id != '') {

      var option_id = false;
      var option_title = false;
      var option_html = false;

      jQuery.post(ajax.url,
        {'action': 'attest_new_lesson', 'title': title, 'course_id': course_id, 'nonce': nonce},
        function(response) {
          if ( response != '' && response != false && response != undefined ) {

            var data = JSON.parse(response);
            if (data.alert != 1) {

              alert(data.alert);
            } else {

              option_id = data.id;
              option_title = data.title;
              option_url = data.url.replace('&amp;', '&');
              option_html = '<option value="' + data.id + '" data-title="' + data.title + '" data-link="' + data.url + '">' + data.title + '</option>';
              condition_html = '<option value="' + data.id + '">' + ajax.lesson_name + ': ' +  data.title + '</option>';

              if (option_id != undefined) {

                var lesson_html = jQuery('#appendFrom').children('#section_container').children('#section').children('#lesson_append_to').html();
                var section_Serial = jQuery(element).parent().parent().parent().children('#section_ID').attr('data-serial');
                var lesson_Serial = jQuery(element).parent().parent().parent().children('#lesson_append_to').children('#lesson_container').last().children('#lesson_ID').attr('data-serial');
                var id = jQuery(element).prev('select#attest_lesson_id option:selected').val();

                if (lesson_Serial == undefined) {
                  var lesson_count = 0;
                } else {
                  var lesson_count = parseInt(lesson_Serial) + 1;
                }

                jQuery('select[id="attest_lesson_id"]').each(function(i, v) {
                  jQuery(v).append(option_html);
                });
                jQuery('select[id="attest_lesson_condition"]').each(function(i, v) {
                  jQuery(v).append(condition_html);
                });

                var count_lessons = jQuery(element).closest('#section_append_to').find('#lesson_container').length;
                jQuery(element).prev('#add_new_lesson').val('');

                var altered_lesson_html = jQuery(lesson_html).find('#lesson_ID').attr('data-serial', lesson_count).end()
                .find('#attest_lesson_id').attr('name', 'attest_curriculum['+section_Serial+']['+lesson_count+'][lesson_id]').end()
                .find('#attest_lesson_id').append(option_html).end()
                .find('#attest_lesson_id>option[value="'+option_id+'"]').attr('selected', true).end()
                .find('#attest_lesson_condition').attr('name', 'attest_curriculum['+section_Serial+']['+lesson_count+'][condition]').end()
                .find('#attest_lesson_condition').append(condition_html).end()
                .find('#lesson_link').attr('href', option_url).end()
                .find('#accordion_title_number_lesson').text(lesson_count+1).end()
                .find('#accordion_title_name_lesson').html(option_title).end();

                if (count_lessons == 0) {
                  altered_lesson_html = altered_lesson_html.find('#attest_lesson_condition').attr('disabled', 'disabled').end();
                } else {
                  altered_lesson_html = altered_lesson_html.find('#attest_lesson_condition').removeAttr('disabled').end()
                  jQuery(element).parent().parent().prev('#lesson_append_to').children('#lesson_container').each(function(i, v) {
                    jQuery(v).find('#attest_lesson_condition').removeAttr('disabled');
                  });
                }

                altered_lesson_html = altered_lesson_html.find('#attest_lesson_condition>option').removeAttr('disabled').end();
                altered_lesson_html = altered_lesson_html.find('#attest_lesson_condition>option[value="'+option_id+'"]').attr('disabled', 'disabled').end();

                jQuery(element).parent().parent().prev('#lesson_append_to').append(altered_lesson_html);

                //Add number to new lesson
                var count = jQuery('#lesson_assessment_count').text();
                var new_count = parseInt(count) + 1;
                jQuery('#lesson_assessment_count, #lesson_assessment_count_more').text(new_count);
              }
            }
          }
        });
      }
  });


  //Delete lesson
  jQuery(document).delegate('.delete_lesson', 'click', function(){
    if (!confirm(ajax.delete_lesson)){
      return false;
    } else {

      //The sequence matters here
      var father_container = jQuery(this).closest('#section_append_to');
      var mother_container = jQuery(this).closest('#lesson_append_to');
      var child_container = jQuery(this).closest('#lesson_container');

      jQuery(this).closest('#lesson_container').remove();

      var count_lessons_obj = father_container.find('#lesson_container');
      var lessons_number_obj = mother_container.find('span[id="accordion_title_number_lesson"]');

      count_lessons_obj.each(function(i, v) {
        if (count_lessons_obj.length <= 1) {
          jQuery(v).find('#attest_lesson_condition').attr('disabled', 'disabled');
        } else {
          jQuery(v).find('#attest_lesson_condition').removeAttr('disabled');
        }
      });
      /**
      var id = child_container.find('option:selected', '#attest_lesson_condition').val();
      child_container.find('#attest_lesson_condition>option[value="' + id + '"]').remove();
      */
      lessons_number_obj.each(function(i,v){
        if (i < lessons_number_obj.length) {
          jQuery(v).text(i+1);
        }
      });

      //Subtract number to new lesson
      var count = jQuery('#lesson_assessment_count').text();
      var new_count = parseInt(count) - 1;
      jQuery('#lesson_assessment_count, #lesson_assessment_count_more').text(new_count);
    }
  });


  //Change lesson name on accordion title
  jQuery(document).delegate('#attest_lesson_id', 'change', function() {
    var id = jQuery('option:selected', this).val();
    var option = jQuery('option:selected', this).attr('data-title');
    var link = jQuery('option:selected', this).attr('data-link');

    var container = jQuery(this).parent().parent().parent().parent().parent().parent('#lesson_container');

    container.find('#lesson_link').attr('href', link);
    container.find('#accordion_title_name_lesson').text(option);
    container.find('#attest_lesson_condition>option').removeAttr('disabled');
    container.find('#attest_lesson_condition>option[value="'+id+'"]').attr('disabled', 'disabled');
  });


  //Save data
  jQuery(document).delegate('.save_rule', 'click', function(){

    var element = this;
    var id = jQuery(this).attr('data-id');
    var nonce = jQuery(this).parent().find('#attest_save_lesson_nonce').val();
    var data = get_attest_curriculum(this);

    if (id != undefined && id != '') {

      jQuery(this).text(ajax.saving_text);

      jQuery.post(ajax.url,
        {'action': 'attest_save_lesson', 'course_id': id, 'data': data, 'nonce': nonce},
        function(response) {
          if ( response != '' && response != false && response != undefined ) {

            var data = JSON.parse(response);
            if (data.alert != 1) {
              alert(data.alert);
            } else {
              jQuery(element).text(ajax.saved_text);
            }
          }
        });
    }
  });


  //Title editor
  jQuery(document).delegate('.edit_section', 'click', function(event){

    event.preventDefault();
    jQuery(this).hide();
    jQuery(this).parent().parent().find('#attest_curriculum_title, #save_title').show();
    jQuery(this).parent().parent().find('#accordion_title_name_section').text('');
  });


  //Edit the section title
  jQuery(document).delegate('.save_title', 'click', function(){

    var element = this;
    var id = jQuery(this).attr('data-id');
    var nonce = jQuery(this).parent().parent().find('#attest_save_lesson_nonce').val();
    var data = get_attest_curriculum(this);

    var title = jQuery(this).prev('#attest_curriculum_title').val();

    if (id != undefined && id != '') {

      jQuery(this).text(ajax.saving_text);

      jQuery.post(ajax.url,
        {'action': 'attest_save_lesson', 'course_id': id, 'data': data, 'nonce': nonce},
        function(response) {
          if ( response != '' && response != false && response != undefined ) {

            var data = JSON.parse(response);
            if (data.alert != 1) {
              alert(data.alert);
            } else {
              jQuery(element).text(ajax.saved_text);
              jQuery(element).parent().parent().find('#accordion_title_name_section').text(title);
              jQuery(element).parent().find('#attest_curriculum_title, #save_title').hide();
              jQuery(element).parent().parent().find('.edit_section').show();
            }
          }
        });
    }
  });


  //Add accordion feature to lessons and sections
  jQuery('.section_close').show();
  jQuery('.section_open').hide();
  jQuery('.section-wrap, .lesson-wrap').hide();
  jQuery(document).delegate('.components-panel_section_body-title', 'click', function(e){
    var toggle = true;
    if (jQuery(e.target).find('.edit_section, #attest_curriculum_title, #save_title').length <= 0) {
      toggle = false;
    }
    if (false != toggle) {
      jQuery(this).find('.section_close, .section_open').toggle();
      jQuery(this).next('.section-wrap').toggle();
    }
  });
  jQuery(document).delegate('.components-panel_lesson_body-title', 'click', function(){
    jQuery(this).find('.lesson_settings').toggle();
    jQuery(this).next().next('.lesson-wrap').toggle();
  });
});
