<?php
if ( ! defined( 'ABSPATH' ) ) exit;

/**
 * Shortcode class for rendering in front end
 */
if ( ! class_exists( 'ATTEST_LMS_STUDENT_REGISTER' ) ) {

	class ATTEST_LMS_STUDENT_REGISTER {


		public $courses_permalink;
		public $secret_key;


    public function __construct() {

			$post_id = get_option('attest_template_courses');
			$this->courses_permalink = get_permalink($post_id);
			$this->secret_key = get_option('attest_secret_key_recaptcha');

			$this->register();
    }


		public function register() {

			if (isset($_POST['attest_submit_register'])) {

				$email = (isset($_POST['attest_email1_register']) ? sanitize_email($_POST['attest_email1_register']) : false);
				$password = (isset($_POST['attest_password_register']) ? sanitize_text_field($_POST['attest_password_register']) : false);
				$confirm_password = (isset($_POST['attest_password_confirm_register']) ? sanitize_text_field($_POST['attest_password_confirm_register']) : false);
				$captcha = (isset($_POST['attest_g_recaptcha-response']) ? sanitize_text_field($_POST['attest_g_recaptcha-response']) : false);

				if($captcha) {

					$ip = $_SERVER['REMOTE_ADDR'];
					$url = 'https://www.google.com/recaptcha/api/siteverify?secret=' . urlencode($this->secret_key) .  '&response=' . urlencode($captcha);
					$response = file_get_contents($url);
					$response_keys = json_decode($response,true);

					if ($response_keys["success"]) {
						if ($email && $password && $confirm_password) {
							if ( is_email($email) && ($password == $confirm_password)) {

								$username = $this->generate_username($email);

								$user_data = array(
	    						'user_login' => $username,
	    						'user_pass'  => $password,
	    						'user_email' => $email,
	    						'role'       => 'attest_student'
								);
								$user = wp_insert_user( $user_data );
								if (! is_wp_error($user)) {

									wp_set_current_user($user, $email);
									wp_set_auth_cookie( $user, false, is_ssl() );
									do_action( 'wp_login', $email );

									wp_safe_redirect($this->courses_permalink);
									exit;

		          	} else {

		            	global $Attest_LMS_Register_Error;
									$Attest_LMS_Register_Error = true;
		          	}
							}
						}
					} else {
						global $Attest_LMS_Register_Error;
						$Attest_LMS_Register_Error = __('You are spammer ! Get out', 'attest');
					}
				} else {
					global $Attest_LMS_Register_Error;
					$Attest_LMS_Register_Error = __('Invalid submission', 'attest');
				}

      }
		}


		public function generate_username($email) {

			$exploded = explode('@', $email);
			return $exploded[0];
		}
  }
}
