<?php
/**
 * Announcement emails sending and formatting
 */
if ( ! defined( 'ABSPATH' ) ) exit;

if ( ! class_exists( 'ATTEST_LMS_ANNOUNCEMENT_EMAIL' ) ) {

	final class ATTEST_LMS_ANNOUNCEMENT_EMAIL {


    public $title;
    public $description;
    public $course_id;
		protected $subject;
		protected $body;


    public function execute() {

			$sent = false;
			$this->subject = get_option('attest_email_announcement_subject');
			$this->body = get_option('attest_email_announcement_body');

      $students = $this->get_students($this->course_id);
      if ($students) {
        foreach($students as $student) {
          $email = $this->get_email($student);

					$title = $this->alter_text($this->subject, $student);
					$description = $this->alter_text($this->body, $student);

          $sent = $this->send_email($email, $title, $description);
        }
      }

			return $sent;
    }


    public function send_email($email, $title, $description) {

			$sent = wp_mail( $email, $title, $description);
      return $sent;
    }


    public function get_students($course_id) {

			$meta = get_post_meta($course_id, 'attest_enrolled_students', false);
			if (false != $meta && count($meta[0]) > 0) {

				return $meta[0];
			} else {

				return false;
			}
    }


    public function get_email($student_id) {

			$email = get_the_author_meta( 'user_email', $student_id);
      return $email;
    }


		public function alter_text($text, $user_id) {

			$user_data = get_userdata( $user_id );

			$text = str_replace( '{first_name}', $user_data->first_name, $text);
			$text = str_replace( '{last_name}', $user_data->last_name, $text);
			$text = str_replace( '{announcement_title}', $this->title, $text);
			$text = str_replace( '{announcement_description}', $this->description, $text);

			return $text;
		}
  }
}
